#include <stdio.h>
#include <string.h>

typedef union {
  unsigned char array[4];
  long number;
} value;

int main (int argc, char *argv[])
{

FILE *filein,*fileout1,*fileout2;
unsigned char *buffer,outimage[25],outpalette[25],r,g,b,rr,gg1,gg2,bb;
int i,j,padding;
value colors,width,height;

    if(argc!=3){
      fprintf(stderr,"usage: %s filein fileout\n",argv[0]);
      exit (-1);
    }
	
    if (!(filein=fopen(argv[1],"r"))) {
      fprintf(stderr,"%s: can not open %s\n",argv[0],argv[1]);
      exit (-1);
    }

    strncpy(outimage,argv[2],20);
    outimage[20]=0;
    strcat(outimage,".pbm");
    if (!(fileout1=fopen(outimage,"w"))) {
      fprintf(stderr,"%s: can not open %s\n",argv[0],outimage);
      exit (-1);
    }
    strncpy(outpalette,argv[2],20);
    outpalette[20]=0;
    strcat(outpalette,".pal");
    if (!(fileout2=fopen(outpalette,"w"))) {
      fprintf(stderr,"%s: can not open %s\n",argv[0],outpalette);
      exit (-1);
    }
    if(!(buffer=(char *)calloc(1024,1))){
      fprintf(stderr,"%s: not enough memory\n",argv[0]);
      exit (-1);
    }      

fread(buffer,1,14+40,filein);      // strip header
memcpy(colors.array,&buffer[54-8],4);
if(colors.number>256){
      fprintf(stderr,"%s: too many colors %ld\n",argv[0],colors.number);
      exit(-1);
}
memcpy(width.array,&buffer[14+4],4);
memcpy(height.array,&buffer[14+8],4);
if(width.number>320 || height.number>320 ){
      fprintf(stderr,"%s: too big %ldx%ld\n",argv[0],width.number,height.number);
      exit(-1);
}
printf("%ld colors %ldx%ld\n",colors.number,width.number,height.number);
padding=width.number&3;                       // padded to nearest multiple of 4
fread(buffer,1,colors.number*4,filein);      // get palette
for(j=1;j<colors.number;j++){
    memmove(buffer+3*j,buffer+4*j,3);      // pack BGR0 -> BGR
}
while(j<256) {                              // clear unused colors
  buffer[3*j]=0;
  buffer[3*j+1]=0;
  buffer[3*(j++)+2]=0;
}
fwrite(buffer,1,3*256,fileout2);
for(i=0;i<height.number;i++){
  fread(buffer,1,width.number+padding,filein);     // get pixels for a whole line
fwrite(buffer,1,width.number,fileout1);  // put to file, strip padding
}
free(buffer);
fclose(filein);
fclose(fileout1);
fclose(fileout2);
}
